
%global commit c08e7e08ef4a59948a36fed17d29c888811e8873
%global shortcommit %(c=%{commit}; echo ${c:0:7})

Name:           spirv-llvm-translator17
Version:        17.0.0
Release:        1%{?dist}
Summary:        LLVM 17 to SPIRV Translator

License:        NCSA
URL:            https://github.com/KhronosGroup/SPIRV-LLVM-Translator
Source0:        %{url}/archive/%{commit}/spirv-llvm-translator-%{shortcommit}.tar.gz

BuildRequires:  gcc
BuildRequires:  gcc-c++
BuildRequires:  cmake
BuildRequires:  ninja-build
BuildRequires:  llvm17-devel
BuildRequires:  llvm17-static
BuildRequires:  spirv-headers-devel
BuildRequires:  spirv-tools-devel
BuildRequires:  zlib-devel

%description
Khronos LLVM 17 to SPIRV Translator. Compatibility package.

%prep
%autosetup -n SPIRV-LLVM-Translator-%{commit} -p1

%build
%cmake -GNinja \
       -DLLVM_BUILD_TOOLS=ON \
       -DCMAKE_BUILD_TYPE=RelWithDebInfo \
       -DCMAKE_INSTALL_RPATH:BOOL=";" \
       -DLLVM_DIR="%{_libdir}/llvm17/lib/cmake/llvm" \
%if 0%{?__isa_bits} == 64
       -DLLVM_LIBDIR_SUFFIX=64 \
%else
       -DLLVM_LIBDIR_SUFFIX= \
%endif
       -DLLVM_EXTERNAL_PROJECTS="SPIRV-Headers" \
       -DLLVM_EXTERNAL_SPIRV_HEADERS_SOURCE_DIR="/usr/include/spirv/"

%cmake_build

%install
%cmake_install

# purge everything but the main .so
# if you need these for something, please do create a PR or issue
rm -f %buildroot%{_bindir}/llvm-spirv
rm -f %buildroot%{_libdir}/pkgconfig/LLVMSPIRVLib.pc
rm -f %buildroot%{_libdir}/libLLVMSPIRVLib.so
rm -rf %buildroot%{_includedir}/LLVMSPIRVLib

%files
%doc README.md
%{_libdir}/libLLVMSPIRVLib.so.*


%changelog
* Wed Mar 06 2024 Frantisek Zatloukal <fzatlouk@redhat.com> - 17.0.0-1
- LLVM 17.0.0 compat package
